//javaӿ
exec = function(service, action, args) {

	var result = prompt("iflytek:" + stringify([service, action]), stringify(args));

	return result;
}
//[xxx,yyy,...]װjson
stringify = function(args) {
	if( typeof JSON === "undefined") {
		var s = "[";
		var i, type, start, name, nameType, a;
		for( i = 0; i < args.length; i++) {
			if(args[i] !== null) {
				if(i > 0) {
					s = s + ",";
				}
				type = typeof args[i];
				if((type === "number") || (type === "boolean")) {
					s = s + args[i];
				} else if(args[i] instanceof Array) {
					s = s + "[" + args[i] + "]";
				} else if(args[i] instanceof Object) {
					start = true;
					s = s + '{';
					for(name in args[i]) {
						if(args[i][name] !== null) {
							if(!start) {
								s = s + ',';
							}
							s = s + '"' + name + '":';
							nameType = typeof args[i][name];
							if((nameType === "number") || (nameType === "boolean")) {
								s = s + args[i][name];
							} else if(( typeof args[i][name]) === 'function') {
								// don't copy the functions
								s = s + '""';
							} else if(args[i][name] instanceof Object) {
								s = s + PhoneGap.stringify(args[i][name]);
							} else {
								s = s + '"' + args[i][name] + '"';
							}
							start = false;
						}
					}
					s = s + '}';
				} else {
					a = args[i].replace(/\\/g, '\\\\');
					a = a.replace(/"/g, '\\"');
					s = s + '"' + a + '"';
				}
			}
		}
		s = s + "]";
		return s;
	} else {
		return JSON.stringify(args);
	}
}
//ݲtextareaڴ
insertText = function(obj, str) {
	if(document.selection) {
		var sel = document.selection.createRange();
		sel.text = str;
	} else if( typeof obj.selectionStart === 'number' && typeof obj.selectionEnd === 'number') {
		var startPos = obj.selectionStart, endPos = obj.selectionEnd, cursorPos = startPos, tmpStr = obj.value;
		obj.value = tmpStr.substring(0, startPos) + str + tmpStr.substring(endPos, tmpStr.length);
		cursorPos += str.length;
		obj.selectionStart = obj.selectionEnd = cursorPos;

		console.log('insertText, cursorPos is ' + cursorPos);
	} else {
		obj.value += str;
	}
}
//ƶtextareaĩβ
moveEnd = function(obj) {
	obj.focus();
	var len = obj.value.length;
	if(document.selection) {
		var sel = obj.createTextRange();
		sel.moveStart('character', len);
		sel.collapse();
		sel.select();
	} else if( typeof obj.selectionStart == 'number' && typeof obj.selectionEnd == 'number') {
		obj.selectionStart = obj.selectionEnd = len;
	}
}
/**
 * ģ
 */
var isTouch = ('ontouchstart' in window);
var Vscroll = function(handle) {
	if(!handle || handle == "" || handle == null)
		handle = this;
	handle.style.overflow = "hidden";
	handle.delay = 2000;
	handle.interval = 20;
	handle.isMove = false;
	var holdEventNodes = [];

	var fixEvent = function(e) {
		console.log("fixEvent begin, event type is " + e.type + " e.layerX is " + e.layerX + " e.pageX is" + e.pageX);
		if( typeof e == "undefined")
			e = window.event;
		if( typeof e.layerX == "undefined")
			e.layerX = e.offsetX;
		if( typeof e.layerY == "undefined")
			e.layerY = e.offsetY;
		if( typeof e.pageX == "undefined")
			e.pageX = e.clientX + document.documentElement.scrollLeft - document.documentElement.clientLeft;
		if( typeof e.pageY == "undefined")
			e.pageY = e.clientY + document.documentElement.scrollTop - document.documentElement.clientTop;

		console.log("fixEvent end, event type is " + e.type + " e.layerX is " + e.layerX + " e.pageX is" + e.pageX);
		return e;
	}
	var moveDown = function(step) {
		if(handle.isMove === false) {
			return;
		}
		// console.log("moveDown begin, step is " + step + " handle.scrollTop is " + handle.scrollTop);

		handle.scrollTop = handle.scrollTop - step;
		//		if(handle.clientHeight+handle.scrollTop - step > handle.scrollHeight){
		//			handle.scrollTop = handle.scrollHeight - handle.clientHeight;
		//		}

		// console.log("moveDown end, step is " + step + " handle.scrollTop is " + handle.scrollTop);
	}
	var start = function(e) {
		console.log("touchstart begin, e.target.nodeName is " + e.target.nodeName + " handle.timeOut is " + handle.timeOut + " isTouch is " + isTouch);
		clearTimeout();
		handle.isMove = false;
		handle.lastTime = e.timeStamp;
		handle.lastMouseY = isTouch ? e.changedTouches[0].pageY : fixEvent(e).pageY;
		handle.stepList = [];
		// e.stopPropagation();

		//ЩnodeǺпҪӦclickhref¼ԲҪΡڵ߹Чʡ
		// if(e.target.nodeName != "#text" && e.target.nodeName != "IMG" && e.target.nodeName != "INPUT" && e.target.nodeName != "TEXTAREA" && e.target.nodeName != "A" && e.target.nodeName != "SELECT" && e.target.nodeName != "BUTTON" && e.target.nodeName != "LABEL") {
		// e.preventDefault();
		// }

		if(holdEventNodes.length >= 1) {
			for(var i = 0; i < holdEventNodes.length; i++) {
				if(e.target.nodeName == holdEventNodes[i]) {
					console.log('e.target.nodeName is ' + e.target.nodeName + ' ==' + holdEventNodes[i]);
					break;
				}

				if(i == holdEventNodes.length - 1) {
					e.preventDefault();
				}
			}
		} else {
			e.preventDefault();
		}

		if(isTouch) {
			handle.addEventListener("touchmove", drags, false);
			handle.addEventListener("touchend", end, false);
		} else {
			handle.addEventListener("mousemove", drags, false);
			handle.addEventListener("mouseup", end, false);
		}
		console.log("start end, handle.lastTime is " + handle.lastTime + " handle.lastMouseY is " + handle.lastMouseY);
		return true;
	};
	var drags = function(e) {
		// console.log("drags begin, handle.timeOut is " + handle.timeOut + " handle.isMove is " + handle.isMove);

		e.preventDefault();
		// e.stopPropagation();
		if(handle.isMove == false) {
			//e.preventDefault();
			// e.stopPropagation();
			clearTimeout();
			handle.isMove = true;
			// return false;
		}
		var newTime = e.timeStamp;
		var pageY = isTouch ? e.changedTouches[0].pageY : fixEvent(e).pageY;

		var step = (pageY - handle.lastMouseY);
		if(Math.abs(step) < 3) {
			console.log("drags move step is " + step + " , so return");
			return;
		}
		var time = (newTime - handle.lastTime);
		handle.stepList.push({
			step : step,
			time : time
		});
		handle.lastTime = newTime;
		moveDown(step);
		handle.lastMouseY = pageY;

		// console.log("drags end, newTime is " + newTime + " pageY is " + pageY + " step is " + step + " time is " + time + " lastMouseY is" + handle.lastMouseY);
		return true;
	};
	var end = function(e) {
		var len = handle.stepList.length;
		
		console.log("touchend begin, len is " + len + " handle.stepLis is " + handle.stepLis);

		var totalStep = 0;
		var totalTime = 0;
		for(var i = len - 1; i >= 0; i--) {
			if(handle.stepList[i].time != 0) {
				totalStep = totalStep + handle.stepList[i].step;
				totalTime = totalTime + handle.stepList[i].time;
				break;
			}
		}
		if(totalTime != 0) {
			var v = totalStep / totalTime;
			var a = (0 - v) / handle.delay;

			afterTouchendMove(v, a);

			//ӿٶ
			// var doubleV = v * 2;
			// afterTouchendMove(doubleV, a);
		}
		if(isTouch) {
			handle.removeEventListener("touchmove", drags, false);
			handle.removeEventListener("touchend", end, false);
		} else {
			handle.removeEventListener("mousemove", drags, false);
			handle.removeEventListener("mouseup", end, false);
		}
		console.log("end end, totalTime is " + totalTime + " totalStep is " + totalStep);

		return true;
	};
	var afterTouchendMove = function(v, a) {
		// console.log("afterTouchendMove begin, v is " + v + " a is " + a);
		var step = v * handle.interval;
		//ȡƶľ
		var newV = v + a * handle.interval;
		// moveDown(step);
		// if(newV * step > 0) {
		// handle.timeOut = window.setTimeout(function() {
		// afterTouchendMove(newV, a);
		// }, handle.interval)
		// } else {
		// handle.isMove = true;
		// }

		if(Math.abs(step) >= 1 && handle.isMove) {
			moveDown(step);
			handle.timeOut = window.setTimeout(function() {
				afterTouchendMove(newV, a);
			}, handle.interval)
		}

		// console.log("afterTouchendMove end, step is " + step + " newV is " + newV);
	}
	var clearTimeout = function() {
		if(handle.timeOut) {
			window.clearTimeout(handle.timeOut);
		}
	}
	if(isTouch) {
		console.log("add touch event listener");
		handle.addEventListener("touchstart", start, false);
	} else {
		handle.addEventListener("mousedown", start, false);
	}

	var hasAdded = true;

	this.stopMove = function() {
		handle.isMove = false;
	}

	this.addScroll = function(holdEventNodesName) {
		if(!hasAdded) {
			if(isTouch) {
				handle.addEventListener("touchstart", start, false);
			} else {
				handle.addEventListener("mousedown", start, false);
			}
			hasAdded = true;
		}

		if(holdEventNodesName) {
			holdEventNodes = holdEventNodesName;
		} else {
			holdEventNodes = [];
		}
	}

	this.removeScroll = function() {
		if(hasAdded) {
			if(isTouch) {
				handle.removeEventListener("touchstart", start, false);
			} else {
				handle.removeEventListener("mousedown", start, false);
			}
			hasAdded = false;
		}
	}
};
